def ctrl?
   require 'Win32API'
   $win32GetKeyStateFunc=Win32API.new("user32.dll", "GetKeyState", ['N'], 'N')
   return (($win32GetKeyStateFunc.call(0xa2)>>16)!=0)
end

def shift?
   require 'Win32API'
   $win32GetKeyStateFunc=Win32API.new("user32.dll", "GetKeyState", ['N'], 'N')
   return (($win32GetKeyStateFunc.call(0xa0)>>16)!=0)
end

##################################################
##Sketchup                                                                                                    ###
##################################################


#find_support_file
#LanguageHandlerʹ֮ʹָĿ¼µstringsļ
#6.4.112ϰ汾
if Sketchup.respond_to?("get_resource_path")
   module Sketchup
      class <<self
         alias_method :old_get_resource_path,:get_resource_path
         def get_resource_path path
            return path if FileTest.exist? path
            old_get_resource_path path
         end
      end
   end
end
#6.4.112°汾
if LanguageHandler.public_instance_methods(false).include?("GetFullPath")
   class LanguageHandler
      alias_method :old_GetFullPath,:GetFullPath
      def GetFullPath(fileName)
         return fileName if FileTest.exist?(fileName)
         old_GetFullPath fileName
      end
   end
end
#LanguageHandler
class Object
   def methods_only
      my_super=self.class.superclass
      return my_super ? methods-my_super.instance_methods : methods
   end
end
module Sketchup
   class  Model
      #Ϊmodelӱ
      #$mm.each_entity{|x| puts x }
      #gpǷȺ齨
      def each_entity_do ents,gp=true
         ents.to_a.each{|x|
            next if x.deleted?
            case true
            when x.class==Sketchup::Group
               if gp
                  each_entity_do(x.entities,gp){|y| yield y}
                  yield x
               else
                  yield x
               end
            when x.class==Sketchup::ComponentInstance
               if gp
                  each_entity_do(x.definition.entities,gp){|y| yield y}
                  yield x
               else
                  yield x
               end
            else
               yield x
            end
         }
      end
      def each_entity gp=nil
         self.definitions.to_a.each{|e| each_entity_do(e.entities,gp){|x| yield x} }
         each_entity_do( self.entities,gp){|x| yield x}
      end
   end
   #Ϊȡĵ㷽
   class Face
      def wi_center#ĵ
         vts=self.vertices.collect{|x| x.position}
         vx=vts.collect{|x| x.x}.wi_average
         vy=vts.collect{|x| x.y}.wi_average
         vz=vts.collect{|x| x.z}.wi_average
         return Geom::Point3d.new([vx,vy,vz])
      end
   end
end
##################################################
##                                                                                                       ###
##################################################
class Array
   def wi_average#ƽֵ
      re=0
      self.each{|x| re+=x}
      return re / self.length
   end
   def to_f
      self.collect!{|v| v.to_f}
      self
   end
   def to_i
      self.collect!{|v| v.to_i}
      self
   end
   #ȷ
   def wi_split_n(n)

      m=(self.length/n)
      re=[]
      i=0
      remain=(self.length%n)
      count=0
      while i < n
         tmp= i<remain ? m+1 : m
         re << self.slice(count,tmp)
         count+=tmp
         i+=1
      end
      re.delete_if{|x| !x or x.length==0}
   end
   #ƶά
   def wi_weave
      re=[]
      max=self.map{|x| x.length}.max
      0.upto(max-1){|i|
         re << self.map{|y| y[i]}.compact
      }
      re
   end
end #class Array


class String
   Sutool.copy_to_system32("iconv.dll")
   def chu_li_yin_hao#ַеŴΪ%Q{ }ģʽ
      if self=~/((\".*?\")|(\'.*?\'))/
         self.gsub!(/((\".*?\")|(\'.*?\'))/,"%Q{\\1}").gsub!(/(\"|\')/,"")
      else
         self
      end
   end
   def utf8?
      unpack('U*') rescue return false
      true
   end
   def to_gbk
      Iconv.iconv("GBK//IGNORE","UTF-8//IGNORE",self).to_s
   end
   def to_utf8
      Iconv.iconv("UTF-8//IGNORE","GBK//IGNORE",self).to_s
   end
   def convert (back=false)#תַ
      return self if !Sketchup.find_support_file "convert.rb"
      require "convert.rb"
      if back
         if utf8?
            self
            else
            to_gbk   
            end
         #~ return Iconv.iconv("uTF-8//IGNORE","GB2312//IGNORE",self)[0] 
      else
         if !utf8?
            self
            else
            to_gbk   
            end
         #~ return Iconv.iconv("GB2312//IGNORE","uTF-8//IGNORE",self)[0]
      end
   end
   def wi_format_path
      self.gsub(/\\/,"/").downcase
   end
end
#Dirչ
class Dir
   class <<Dir
      def wi_all_entries(path)
         all=Dir.entries(path)-[".",".."]
         all.collect{|x|
            x=path+"/"+x
            if File.ftype(x)=="directory"
               Dir.wi_all_entries(x)
            else
               x
            end
         }
      end
      def mkdirs path#ļнṹ
         return true if File.exist?(path)
         return nil if !File.exist?(path[0..1])
         mkdirs File.dirname(path) if !File.exist?(File.dirname(path))
         return Dir.mkdir( path)
      end
      def xcopy fd1,fd2,pat=".*"#xcopy
         #~ p fd2
         #~ p pat
         pat=Regexp.new(pat, true)
         return nil if !(mkdirs fd2)
         Dir.entries(fd1).each{|x|
            #~ p x
            next if [".",".."].include?( x)
            next if !x=~pat
            fd1_f=fd1+"/"+x
            fd2_f=fd2+"/"+x
            #~ puts fd1_f
            if FileTest.directory?( fd1_f)
               xcopy fd1_f,fd2_f
            else
               File.copy fd1_f,fd2_f
            end
         }
      end
   end
end
#Fileչ
class File
   class << File
      def copy f1,f2#ļ
         return nil if !File.exist?(f1)
         p dirname(f2)
         return nil if !Dir.mkdirs(dirname(f2))
         f1_f=open(f1,"rb")
         f2_f=new(f2,"wb")
         f1_f.each {|x|f2_f.puts x}
         f2_f.close
         f1_f.close
      end
   end
end
