module Delete_CG_mat
	def self.tool
		model = Sketchup.active_model
		ents = model.active_entities
		@n = 0
		model.start_operation "Delete comp & group materials"
		Sketchup.set_status_text "Program is running...", SB_PROMPT
		self.boucle ents
		Sketchup.set_status_text "Done! "+@n.to_s+" material components/groups deleted." , SB_PROMPT
		model.commit_operation
	end
	
	def self.boucle(sel)
		for e in sel
			case e.typename
				when "Group","ComponentInstance"
			if e.material && (e.material != nil)
					e.material=nil
					@n += 1
				end
				self.boucle(e.entities) if e.typename == "Group"
				self.boucle(e.definition.entities) if e.typename == "ComponentInstance"
			end
		end
	end
end

UI.menu("Plugins").add_item("Del CG materials"){Delete_CG_mat.tool} if(not file_loaded?("Delete CG mat.rb"))
file_loaded("Delete CG mat.rb")