module Wikii_tools
   #curveתΪ˵вͬz߶ȵĿռ
   def Wikii_tools.curve_delta_z
	   @mm=Sketchup.active_model
	   @ss=@mm.selection
	   @ee=@mm.active_entities
      @mm.start_operation "curve_delta_z"
      gp=@ee.add_group
      delta_z=nil
      cs=@ss.to_a.select{|x| x.typename=="Edge" and x.curve}
	  if cs.empty?
		  UI.messagebox "Please select one curve at least."
		  return
	  end
	  
	  cs.map!{|x| x.curve}.uniq
      cs.each{|c|
         vs=c.vertices
         len=c.length
		 #~ p delta_z
		 delta_z=len/5 if !delta_z
         n=0
         v=vs[0]
         vs_info=[v.position]
         start_z=v.position.z
         vs[1..-1].each{|x|
            n+=x.position.distance(v.position)
            pt = x.position
            pt.z= n/len*delta_z+start_z
            vs_info << pt
            v=x
         }
         gp.entities.add_curve vs_info
      }
      @mm.commit_operation
      @ss.clear
      #~ p gp
      @ss.add gp
      Sketchup.send_action "selectScaleTool:"
   end
end
#~ Wikii_tools.curve_delta_z
if !file_loaded?("curve_delta_z.rb")  #and !defined?(Sutool))
   plugins_menu = UI.menu("Plugins").add_submenu("Wikii Tools")
   plugins_menu.add_item("Curve_Delta_Z") { Wikii_tools.curve_delta_z }
end

file_loaded("curve_delta_z.rb")