#-----------------------------------------------------------------------------
# Name        :   extrud_selected_faces_along_normal
# Author      :   wikii  @ sketchupbbs.com
# Description :   A script to extrud_selected_faces_along_normal
# Menu Item   :   Plugins->extrud_faces_along_normal
# Usage       :   select "Show All" from the plugins Menu
# Date        :   05/15/2005
# Type        :   tool
#-----------------------------------------------------------------------------
require 'sketchup.rb'

def extrude_faces_along_normal
   dist=inputbox ["߶ȣ"], ["0"] , ""
   $mm.start_operation "extrude_faces_along_normal"
   Sketchup.active_model.selection.each{|e| if e.typename == "Face" then
      e.pushpull Float( dist[0].to_f.mm)
   end

}
$mm.commit_operation
end

if( not file_loaded?("extrude_faces_along_normal.rb") )
   add_separator_to_menu("Plugins")
   UI.menu("Plugins").add_item("extrude_faces_along_normal") {extrude_faces_along_normal}
end

file_loaded("extrude_faces_along_normal.rb")
