#author:wikii
#version:0.01
#date:20080312
#description:
#version:0.01
#date:20080312
#description:
require "sketchup"
require "cleanup_model.rb"
class Extrude_Edge_with_width
   class << self
      def offset edge,normal,w
         sp=edge.vertices[0].position
         ep=edge.vertices[1].position
         ver=ep-sp
         ver.length=w
         trans=Geom::Transformation.rotation [0,0,0], normal, 90/-180.0*Math::PI
         ver.transform! trans
         sp1=sp+ver
         ep1=ep+ver
         trans=Geom::Transformation.rotation [0,0,0], normal, 180/-180.0*Math::PI
         ver.transform! trans
         sp2=sp+ver
         ep2=ep+ver
         [sp1,ep1,ep2,sp2]
      end
      def go
         model=Sketchup.active_model
         selection=model.selection
         selection.each {|e|
            if e.typename == "Face"
               selection.remove e
            end
         }
         ents=selection[0].parent.entities
         model.start_operation "Extrude_Edge_with_width"
         prompts = ["","߶"]
         @w="60" if !@w
         @h="100" if !@h
         values =[@w,@h]
         popups = [nil,nil]
         results = inputbox( prompts, values, popups, "" )
         return if !results
         @w=results[0]
         @h=results[1]
         w=results[0].to_f/2
         h=results[1].to_f
         egdes=selection.to_a.delete_if{|x| x.class!=Sketchup::Edge}
         vers=[]
         egdes.each{|x| vers+=x.vertices.collect{|y| y.position}}
         
         
         if egdes.length==1
            #ֻһʹxpƽ
            plan = [0,0,1,0]
            else
         plan=Geom.fit_plane_to_points vers
        end
   
         normal=plan[0..2]
         gp=ents.add_group
         ge=gp.entities
         egdes.each{|x|
            ge.add_face(offset x,normal,w.mm)
         }
         ge.intersect_with( true, gp.transformation,gp, gp.transformation, true, gp)
         selection.clear
         ge.each{|x| selection.add x}
         #
         Cleanup.cleanup_selected
         view=model.active_view
         camera=view.camera
         target = camera.target
         eye=camera.eye
         ca_ver=target-eye
         fc=[]
         ge.each{|x| fc<<x if x.class==Sketchup::Face }
         fc.each{|x|
            dir= ca_ver.angle_between( x.normal).abs<Math::PI/2 ? -1 : 1
            x.pushpull( h.mm*dir,false )
         }
         model.commit_operation
      end
   end
end
