class GreyScale
   attr_reader :back_color
   def initialize
      @back_color={}
   end
   def grey
      if ctrl?
         back
      else
         go
      end
   end
   def go
      Sketchup.active_model.start_operation  ""
      Sketchup.active_model.materials.each{|x|
         r=x.color.red
         g=x.color.green
         b=x.color.blue
         @back_color[x]=x.color if r!=g or g!=b or r!=b
         greyscale =((r * 0.3) + (g * 0.59) + (b * 0.11)).to_i
         #~ nc=Sketchup::Color.new(greyscale,greyscale,greyscale)
         nc=Sketchup::Color.new(0,0,0)
         x.color=nc
      }
      Sketchup.active_model.commit_operation
   end

   def back
      Sketchup.active_model.start_operation  ""
      @back_color.each{|x,y|
         x.color=y if !x.deleted?
      }
      Sketchup.active_model.commit_operation
   end
end
$greyScale=GreyScale.new
