=begin rdoc
= Shape Bender
Copyright 2009, Chris Fullmer
All Rights Reserved

== Disclaimer
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE.

== License
Copyright 2009, Chris Fullmer
You may not alter, publish, market, distribute, give, transfer, sell or sublicense the Scripts or any part of this Script.

== Information
See clf_perpendicular_face_tools.rb inside the folder by the same name for further details.
=end

require 'sketchup.rb'
require 'extensions.rb'
require 'progressbar.rb'

ext = SketchupExtension.new("Shape bender", "clf_shape_bender/clf_shape_bender.rb")
ext.name = "Shape Bender"
ext.description = "Bend a shape to match an existing cruve"
ext.version = "0.5 beta"
ext.creator = "Chris Fullmer, distributed at www.sketchucation.com"
ext.copyright = "2009, Chris Fullmer"

Sketchup.register_extension(ext, true)