require 'sketchup.rb'
Sketchup::require 'CompoSpray/CompoSpray'
Sketchup::require 'CompoSpray/CompoTools'
Sketchup::require 'CompoSpray/CompoUtils'

compSpray_env()

if (!file_loaded?("compoSprayToolbar.rb"))
	# Standard menu
	menu = UI.menu("Draw")
	menu.add_item("Components Spray") { compoSpray_main() }
	# Toolbar
	cs_tb = UI::Toolbar.new("Components Spray")
	cmd1 = UI::Command.new(("Components Spray")) { compoSpray_main() }
	cmd1.small_icon = "CompoSpray/IMAGES/cs_Small.png"
	cmd1.large_icon = "CompoSpray/IMAGES/cs_Large.png"
	cmd1.tooltip = "Components Spray"
	cs_tb.add_item(cmd1)
end
file_loaded?("compoSprayToolbar.rb")
