def group_each_face
   fs=[]
   Sketchup.active_model.selection.each{|x| fs<<x if x.typename==%Q{Face}}
   Sketchup.active_model.start_operation "group_each_face"
   fs.each{|x| Sketchup.active_model.active_entities.add_group x }
   Sketchup.active_model.commit_operation
end


def group_each_curve
   edges=[]
   Sketchup.active_model.selection.each{|x|
   edges<<x if x.typename=="Edge"}
   curves=[]
   used_edges=[]
   edges.each{|x|
      next if used_edges.include?(x)
      connected_edges=x.all_connected
      connected_edges=connected_edges & edges
      curves<<connected_edges
      used_edges+=connected_edges
   }
   Sketchup.active_model.start_operation "weld"
   curves.each{|x|
      Sketchup.active_model.active_entities.add_group  x
   }
   Sketchup.active_model.commit_operation
end


def group_each_body
Sketchup.active_model.selection.select{|x| x.class==Sketchup::Edge}.map{|x| x.all_connected.sort{|a,b| a.to_s<=>b.to_s}}.uniq.each{|x|
Sketchup.active_model.active_entities.add_group(x)
}
end